<?php
class CAPTCHA
{
	var $str = '';
	var $image;
	function CAPTCHA()
	{
		$this->str = $this->getstring(5);
		$this->image = $this->make();
	}
	function getstring($size)
	{
		$chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		for($i = 0;$i < $size;$i++)
		{
			$string = $string.$chars[rand(0,51)];
		}
		return $string;
	}
	function make()
	{
		$image = imagecreate(200, 75);
		$black = imagecolorallocate($image, 0, 0, 0);
		$white = imagecolorallocate($image, 255, 255, 255);
		$font = rand(1,2);
		imagefill($image, 0, 0, $white);
		imagestring($image, $font, 20, 10, $this->str, $black);
		imageline($image, rand(5, 50), rand(5, 20), rand(5, 50), rand(5, 20), $black);
		$xoff = rand(-20, 0);
		$yoff = rand(-10, 5);
		$x = 0;
		$y = 0;
		$xshift = imagecreate(200, 75);
		imagecopyresized($xshift, $image, -70, -40, 0, 0, 1000, 375, 200, 75);
		$image = $xshift;
		$xshift = imagecreate(200, 75);
		imagefill($xshift, 0, 0, $white);
		$xshiftfactor = rand(1,4);
		for($i = 0;$i < 75;$i++)
		{
			imagecopyresampled($xshift, $image, $xoff+$x, $i, 0, $i, 200, 1, 200, 1);
			if($x != $xshiftfactor)
			{
				$x++;
			}
			else
			{
				$xshiftfactor = rand(1,3);
				$x = 0;
			} 
		}
		$yshift = imagecreate(200, 75);
		imagefill($yshift, 0, 0, $white);
		$yshiftfactor = rand(1,3);
		for($i = 0;$i < 200;$i++)
		{
			imagecopyresampled($yshift, $xshift, $i, $yoff+$y, $i, 0, 1, 75, 1, 75);
			if($y != $yshiftfactor)
			{
				$y++;
			}
			else
			{
				$yshiftfactor = rand(1,3);
				$y = 0;
			}
		}
		return $yshift;
	}
	function display()
	{
		header('Content-type: image/png');
		imagepng($this->image);
		imagedestroy($this->image);
	}
}
?>