<?php
//extension installer/validator

//function erase_file($file) the function is here incase someone wants to use it w/o BOAS.
//{
//	$erase = fopen($file, "w") or die("Could not erase file $file.");
//	fclose($erase);
//}

function find_code($find, $file)
{
	$linefound[0] = false;
	for($i = 0;$i < count($file);$i++)
	{
		if($file[$i] == $find[0])
		{
			$linefound[0] = $i;
			break;
		}
	}
	if($linefound[0] === false)
	{
		return false;
	}
	if(count($find) > 1)
	{
		$j = 1;
		for($i = $linefound[0] + 1;$i < count($file);$i++)
		{
			if($j == count($find))
			{
				break;
			}
			if($file[$i] == $find[$j])
			{
				if($j != 0)
				{
					$linefound[1] = $i;
				}
				else
				{
					$linefound[0] = $i;
				}
			}
			else
			{
				$j = -1;
			}
			$j++;
		}
		if($linefound[1] - $linefound[0] != count($find) - 1)
		{
			return false;
		}
	}
	else
	{
		$linefound[1] = $linefound[0];
	}
	return $linefound;
}

function strpos_array($haystack, $needles)
{
	for($i = 0;$i < count($needles);$i++)
	{
		if(strpos($haystack, $needles[$i]) !== false)
		{
			return strpos($haystack, $needles[$i]);
		}
	}
	return false;
}

function ins_extension($ext, $ins, $fname = false)
{
	if(($fname !== false) && file_exists("./extensions/$ext/$fname.txt"))
	{
		$file = file("./extensions/$ext/$fname.txt");
	}
	else
	{
		$file = explode("\n", stripslashes($ext));
	}
	if(strpos($file[0], "version(") === 0)
	{
		$version = preg_replace("/version\(\"(.*?)\"\)/i", "$1|", $file[0]);
		$version = substr($version,0,strpos($version, "|"));
	}
	else
	{
		$version = "0.3.0";
	}
	if($version == "Unified Diff") //diff conversion
	{
		include "./extensions/lib/diff.php";
		unset($file[0]);
		$ext = convert_diff($file);
		return ins_extension($ext, $ins, false);
	}
	else
	{
		if(!file_exists("./extensions/lib/BOASL$version.php"))
		{
			return "Library missing for BOASL version $version.";
		}
		include "./extensions/lib/BOASL$version.php";
		$return = interpret_extension($ext, $ins, $fname);
		return $return;
	}
}
?>