<?php
//version 0.2.0

//filename required if extension name is used.
//interpret_extension(str extension_name or source, int install[, str filename])
//if install is 2 it will uninstall.
function interpret_extension($ext, $ins, $fname = false)
{
	if(($fname !== false) && file_exists("./extensions/$ext/$fname.txt"))
	{
		$file = file("./extensions/$ext/$fname.txt");
	}
	else
	{
		//small change in the system required this
		$write = fopen("./extensions/temp.txt", "w");
		fwrite($write, stripslashes($ext));
		fclose($write);
		$file = file("./extensions/temp.txt");
		unlink("./extensions/temp.txt");
	}
	if(!empty($file))
	{
		$i = 0;
		$open = "";
		$failed = false;
		$block = array(0,0);
		$line = 0;
		$openedfile = array();
		$keywords = array(
			"#",
			"open(",
			"new(",
			"requirement(",
			"version(",
			"extension(",
			"update(",
			"Find:",
			"Find If Failed:",
			"Add:",
			"Insert:",
			"Replace:"
		);
		if(strpos($file[0], "version(") === 0)
		{
			$i++;
		}
		while($i < count($file))
		{
			if(strpos($file[$i], "#") === 0)
			{
				$i++;
			}
			//uninst
			elseif($ins === 2)
			{
				if(strpos($file[$i], "open(") === 0)
				{
					$open = preg_replace("/open\(\"(.*?)\"\)/i", "$1|", $file[$i]);
					$open = substr($open,0,strpos($open, "|"));
					if(!file_exists("./$open") || strpos("./".$open, "/../") !== false)
					{
						$i++;
						return "Invalid path/filename.  On line $i.";
					}
					$i++;
					$openedfile = file("./$open");
					$findcode = $openedfile;
					$block[0] = 0;
					$block[1] = count($openedfile) - 1;
				}
				elseif(strpos($file[$i], "new(") === 0)
				{
					if(unlink($open) === false)
					{
						return "Could not delete file $open.";
					}
					$i++;
				}
				elseif(strpos($file[$i], "requirement(") === 0 || strpos($file[$i], "update(") === 0)
				{
					$i++;
				}
				elseif(strpos($file[$i], "extension(") === 0)
				{
					$extensionfile = file("./extensions/extensions.php");
					erase_file("./extensions/extensions.php");
					$write = fopen("./extensions/extensions.php", "a");
					for($j = 0;$j < count($extensionfile);$j++)
					{
						if(strpos($extensionfile[$j], "\$extension[\"".$ext."\"]") === false)
						{
							fwrite($write, $extensionfile[$j]);
						}
					}
					unset($extensionfile);
					$i++;
				}
				elseif(strpos($file[$i], "Find:") === 0 || (strpos($file[$i], "Find If Failed:") === 0 && $failed == true))
				{
					$line = $i;
					unset($code);
					unset($findcode);
					$i++;
					//attempt to find a replace
					$j = $i;
					while(strpos_array($file[$j], array("Replace:", "Find:", "Find If Failed:", "open(")) !== 0)
					{
						if($j == count($file))
						{
							break;
						}
						else
						{
							$j++;
							if(strpos($file[$j], "Replace:") === 0)
							{
								$j++;
								$replace = true;
								break;
							}
						}
					}
					//store Find: code for later use
					while(strpos_array($file[$i], $keywords) !== 0)
					{
						if($i == count($file))
						{
							break;
						}
						else
						{
							$findcode[] = $file[$i];
							$i++;
						}
					}
					if(isset($replace))
					{
						while(strpos_array($file[$j], $keywords) !== 0)
						{
							if($j == count($file))
							{
								break;
							}
							else
							{
								$code[] = $file[$j];
								$j++;
							}
						}
					}
					else
					{
						$code = $findcode;
					}
					$block = find_code($code, $openedfile);
					if(is_array($block))
					{
						$foundcode = $code;
						$failed = false;
					}
					else
					{
						if(strpos($file[$i], "Find If Failed:") !== 0)
						{
							$line++;
							return "Block not found on line $line.";
						}
						else
						{
							$failed = true;
						}
					}
				}
				elseif(strpos($file[$i], "Add:") === 0 || strpos($file[$i], "Insert:") === 0)
				{
					unset($code);
					$i++;
					$line = $i;
					while(strpos_array($file[$i], $keywords) !== 0)
					{
						if($i == count($file))
						{
							break;
						}
						else
						{
							$code[] = $file[$i];
							$i++;
						}
					}
					$block2[0] = $block[0] - count($code);
					$block2[1] = $block[1] - count($code);
					if(!is_array($block2))
					{
						return "Could not find block at line $line.";
					}
					else
					{
						if(!is_writable($open))
						{
							return "Improper permissions for $open!";
						}
						erase_file($open);
						$write = fopen($open, "a");
						for($j = 0;$j < count($openedfile);$j++)
						{
							if($j < $block2[0] || $j > $block2[1])
							{
								fwrite($write, $openedfile[$j]);
							}
						}
						fclose($write);
						$openedfile = file($open);
						$block = find_code($foundcode, $openedfile);
					}
					unset($block2);
				}
				elseif(strpos($file[$i], "Replace:") === 0)
				{
					unset($code);
					$i++;
					while(strpos_array($file[$i], $keywords) !== 0)
					{
						if($i == count($file))
						{
							break;
						}
						else
						{
							$code[] = $file[$i];
							$i++;
						}
					}
					if(!is_writable($open))
					{
						return "Imporper permissions for $open!";
					}
					erase_file($open);
					$write = fopen($open, "a");
					for($j = 0;$j < count($openedfile);$j++)
					{
						if($j >= $block[0] && $j <= $block[1])
						{
							if($j == $block[0])
							{
								for($k = 0;$k < count($findcode);$k++)
								{
									fwrite($write, $findcode[$k]);
								}
							}
						}
						else
						{
							fwrite($write, $openedfile[$j]);
						}
					}
					fclose($write);
					$openedfile = file($open);
				}
				elseif(strpos($file[$i], "run(") === 0)
				{
					return true;
				}
				else
				{
					$i++;
					return "Unknown command or function at line $i.";
				}
			}
			//inst
			elseif(strpos($file[$i], "open(") === 0)
			{
				$open = preg_replace("/open\(\"(.*?)\"\)/i", "$1|", $file[$i]);
				$open = substr($open,0,strpos($open, "|"));
				if(!file_exists("./$open") || strpos("./".$open, "/../") !== false)
				{
					$i++;
					return "Invalid path/filename.  On line $i.";
				}
				$i++;
				$openedfile = file("./$open");
				$block[0] = 0;
				$block[1] = count($openedfile) - 1;
			}
			elseif(strpos($file[$i], "new(") === 0)
			{
				$open = preg_replace("/new\(\"(.*?)\"\)/i", "$1|", $file[$i]);
				$open = substr($open,0,strpos($open, "|"));
				$i++;
				if(strpos("./$open", "/../") === false || !file_exists("./$open"))
				{
					if($ins == 1)
					{
						$write = fopen($open, "a");
					}
					while(strpos_array($file[$i], $keywords) !== 0)
					{
						if($i == count($file))
						{
							break;
						}
						else
						{
							if($ins == 1)
							{
								fwrite($write, $file[$i]);
							}
							$i++;
						}
					}
					if($ins == 1)
					{
						fclose($write);
					}
				}
				else
				{
					$i++;
					return "Invalid path/filename. On line $i";
				}
			}
			elseif(strpos($file[$i], "requirement(") === 0)
			{
				include "./extensions/extensions.php";
				$requirement = preg_replace("/requirement\(\"(.*?)\"\)/i", "$1", $file[$i]);
				$requirement = substr($requirement,0,-2);
				for($j = 0;$j < count($extension);$j++)
				{
					if($extension["name"] == $requirement)
					{
						$met = true;
					}
				}
				if($met == false)
				{
					return "Required extension $requirement not found.";
				}
				unset($extension, $met, $requirement);
				$i++;
			}
			elseif(strpos($file[$i], "extension(") === 0)
			{
				if($fname == false)
				{
					$i++;
				}
				else
				{
					$extinfo = preg_replace("/extension\(\"(.*?)\", (.*?), (.*?), (.*?), (.*?)\)/i", "$1|$2|$3|$4|$5|", $file[$i]);
					$extinfo = substr($extinfo, 0, -1);
					$extinfo = explode("|", $extinfo);
					$extinfo = "\$extension[\"".$ext."\"] = array(\"version\" => \"".$extinfo[0]."\", \"cp\" => \"".$extinfo[1]."\", \"init\" => \"".$extinfo[2]."\", \"config\" => \"".$extinfo[3]."\", \"uninst\" => \"".$extinfo[4]."\");\n";
					$extensionfile = file("./extensions/extensions.php");
					if($ins == 1)
					{
						erase_file("./extensions/extensions.php");
						$write = fopen("./extensions/extensions.php", "a");
						for($j = 0;$j < count($extensionfile);$j++)
						{
							if($j == count($extensionfile) - 1)
							{
								fwrite($write, $extinfo);
							}
							fwrite($write, $extensionfile[$j]);
						}
					}
					$i++;
					unset($extensionfile);
				}
			}
			elseif(strpos($file[$i], "update(") === 0)
			{
				$extinfo = preg_replace("/update\(\"(.*?)\", (.*?)\)/i", "$1|$2|", $file[$i]);
				$extinfo = explode("|", $extinfo);
				$extinfo[0] = explode("/", $extinfo[0]);
				if($extinfo[0][0] == "config")
				{
					if($fname === false) //executed from console
					{
						$var = "\$_bitowl";
						$configfilename = "./config.php";
					}
					else
					{
						$var = "\$_$ext";
						$configfilename = "./extensions/$ext/config.php";
					}
					for($j = 1;$j < count($extinfo[0]);$j++)
					{
						$var = $var."[\"".$extinfo[0][$j]."\"]";
					}
					$configfile = file($configfilename);
					$found = false;
					for($j = 0;$j < count($configfile);$j++)
					{
						if(strpos($configfile[$j], $var) !== false)
						{
							$configfile[$j] = $var." = ".$extinfo[1].";\n";
							$found = true;
						}
					}
					if($found == false) //if not found add to config.
					{
						$found = count($configfile) - 1;
						$configfile[$found] = $var." = ".$extinfo[1].";\n";
						$configfile[] = "?>";
					}
					if($ins == 1)
					{
						$write = fopen($configfilename, "w");
						fwrite($write, implode("", $configfile));
						fclose($write);
					}
				}
				elseif($extinfo[0][0] == "extension")
				{
					include "./extensions/extensions.php";
					if($fname === false)
					{
						return "Unable to use type ".$extinfo[0][0]." on line $i.";
					}
					$extension[$ext]["version"] = $extinfo[0][1] == "version" ? $extinfo[1] : $extension[$ext]["version"];
					$extension[$ext]["cp"] = $extinfo[0][1] == "cp" ? $extinfo[1] : $extension[$ext]["cp"];
					$extension[$ext]["init"] = $extinfo[0][1] == "init" ? $extinfo[1] : $extension[$ext]["init"];
					$extension[$ext]["config"] = $extinfo[0][1] == "config" ? $extinfo[1] : $extension[$ext]["config"];
					$extension[$ext]["uninst"] = $extinfo[0][1] == "uninst" ? $extinfo[1] : $extension[$ext]["uninst"];
					$var = "\$extension[\"$ext\"] = array(\"version\" => ".$extension[$ext]["version"].", \"cp\" => ".$extension[$ext]["cp"].", \"init\" => ".$extension[$ext]["init"].", \"config\" => ".$extension[$ext]["init"].", \"uninst\" => ".$extension[$ext]["uninst"].");\n";
					$configfile = file("./extensions/extensions.php");
					for($j = 0;$j < count($configfile);$j++)
					{
						if(strpos($configfile[$j], "\$extension[\"$ext\"]") !== false)
						{
							$configfile[$j] = $var;
						}
					}
					if($ins == 1)
					{
						$write = fopen("./extensions/extensions.php", "w");
						fwrite($write, implode("", $configfile));
						fclose($write);
					}
					unset($extension);
				}
				else
				{
					return "Unkown type ".$extinfo[0][0]." on line $i.";
				}
				$i++;
			}
			elseif(strpos($file[$i], "Find:") === 0 || (strpos($file[$i], "Find If Failed:") === 0 && $failed == true))
			{
				$line = $i;
				unset($code);
				$i++;
				while(strpos_array($file[$i], $keywords) !== 0)
				{
					if($i == count($file))
					{
						break;
					}
					else
					{
						$code[] = $file[$i];
						$i++;
					}
				}
				$block = find_code($code, $openedfile);
				if(is_array($block))
				{
					$foundcode = $code;
					$failed = false;
				}
				else
				{
					if(strpos($file[$i], "Find If Failed:") !== 0)
					{
						$line++;
						return "Block not found on line $line.";
					}
					else
					{
						$failed = true;
					}
				}
			}
			elseif(strpos($file[$i], "Add:") === 0)
			{
				unset($code);
				$i++;
				while(strpos_array($file[$i], $keywords) !== 0)
				{
					if($i == count($file))
					{
						break;
					}
					else
					{
						$code[] = $file[$i];
						$i++;
					}
				}
				if($ins > 0)
				{
					if(!is_writable($open))
					{
						return "Improper permissions for $open!";
					}
					erase_file($open);
					$write = fopen($open, "a");
					for($j = 0;$j < count($openedfile);$j++)
					{
						fwrite($write, $openedfile[$j]);
						if($j == $block[1])
						{
							for($k = 0;$k < count($code);$k++)
							{
								fwrite($write, $code[$k]);
							}
						}
					}
					fclose($write);
					$openedfile = file($open);
					$block = find_code($foundcode, $openedfile);
				}
			}
			elseif(strpos($file[$i], "Insert:") === 0)
			{
				unset($code);
				$i++;
				while(strpos_array($file[$i], $keywords) !== 0)
				{
					if($i == count($file))
					{
						break;
					}
					else
					{
						$code[] = $file[$i];
						$i++;
					}
				}
				if($ins > 0)
				{
					if(!is_writable($open))
					{
						return "Improper permissions for $open!";
					}
					erase_file($open);
					$write = fopen($open, "a");
					for($j = 0;$j < count($openedfile);$j++)
					{
						if($j == $block[0])
						{
							for($k = 0;$k < count($code);$k++)
							{
								fwrite($write, $code[$k]);
							}
						}
						fwrite($write, $openedfile[$j]);
					}
					fclose($write);
					$openedfile = file($open);
					$block = find_code($foundcode, $openedfile);
				}
			}
			elseif(strpos($file[$i], "Replace:") === 0)
			{
				unset($code);
				$i++;
				while(strpos_array($file[$i], $keywords) !== 0)
				{
					if($i == count($file))
					{
						break;
					}
					else
					{
						$code[] = $file[$i];
						$i++;
					}
				}
				if($ins == 1)
				{
					if(!is_writable($open))
					{
						return "Improper permissions for $open!";
					}
					erase_file($open);
					$write = fopen($open, "a");
					for($j = 0;$j < count($openedfile);$j++)
					{
						if($j >= $block[0] && $j <= $block[1])
						{
							if($j == $block[0])
							{
								for($k = 0;$k < count($code);$k++)
								{
									fwrite($write, $code[$k]);
								}
							}
						}
						else
						{
							fwrite($write, $openedfile[$j]);
						}
					}
					fclose($write);
				}
			}
			elseif(strpos($file[$i], "run(") === 0)
			{
				$run = preg_replace("/run\(\"(.*?)\"\)/i", "$1|", $file[$i]);
				$run = substr($run, 0, strpos($run, "|"));
				if($ins == 1)
				{
					if($fname === false)
					{
						$ext = "./";
					}
					else
					{
						$ext = "./extensions/$ext/";
					}
					echo "<meta http-equiv=\"Refresh\" content=\"0;url=$ext$run\"><a href=\"$ext$run\">Continue</a><br><br>";
				}
				return true; //discontinue execution
			}
			else
			{
				$i++;
				return "Unknown command or function at line $i.";
			}
		}
		return true;
	}
	else
	{
		return true;
	}
}
?>