<?php
if(!defined("bitowl"))
{
	die();
}
include "./feeds/feedlib.php";
include_body(1);
include "menu.php";
include_body(2);
if(isset($_GET["edit"]) || isset($_GET["newfeed"]))
{
	$edit = isset($_GET["edit"]) ? true : false;
	?>
	<form method="post" action="?cp=news&func=feeds">
	<?php if($edit){ ?><input type="hidden" name="id" value="<?php echo $_GET["edit"]; ?>"><?php } ?>
	<table border="0" cellspacing="1" cellpadding="1">
		<tr>
			<td align="right">Feed Name</td>
			<td><input type="text" name="name" <?php if($edit){ ?>value="<?php echo $feed[$_GET["edit"]]["name"]; ?>"<?php } ?> size="40"></td>
		</tr>
		<tr>
			<td align="right">Description</td>
			<td><input type="text" name="description" <?php if($edit){ ?>value="<?php echo $feed[$_GET["edit"]]["description"]; ?>"<?php } ?> size="40"></td>
		</tr>
		<tr>
			<td align="right" valign="top">URL</td>
			<td><input type="text" name="url" <?php if($edit){ ?>value="<?php echo $feed[$_GET["edit"]]["url"]; ?>"<?php } ?> size="40"><br>
				<span style="font-size: 12">This is the URL of the site to plan to display the news on.</span></td>
		</tr>
		<tr>
			<td align="right" valign="top">Query</td>
			<td><input type="text" name="query" <?php if($edit){ ?>value="<?php echo $feed[$_GET["edit"]]["query"]; ?>"<?php } ?> size="40"><br>
				<span style="font-size: 12">anything that goes after the ? in the url (leave blank if nothing).</span></td>
		</tr>
		<tr>
			<td align="right" valign="top">Filename</td>
			<td><input type="text" name="file" <?php if($edit){ ?>value="<?php echo $feed[$_GET["edit"]]["file"]; ?>"<?php } ?> size="40"><br>
				<span style="font-size: 12">Relative to the script's directory use ../ to go back a directory.</span></td>
		</tr>
		<tr>
			<td align="right" valign="top">Categories</td>
			<td>
				<select name="category[]" multiple="multiple" size="4">
				<?php
				for($i = 0;$i < count($categories);$i++)
				{
					echo "<option value=\"$i\"";
					if($edit && strpos(implode("|", $feed[$_GET["edit"]]["categories"]), (string) $categories[$i]["id"]) !== false)
					{
						echo " selected=\"selected\"";
					}
					echo ">".$categories[$i]["name"]."</option>";
				}
				?>
				</select>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><?php 
					if(isset($_GET["edit"]))
					{
						echo "<input type=\"submit\" value=\"Edit\">";
					}
					else
					{
						echo "<input type=\"submit\" value=\"Add\">";
					} ?></td>
		</tr>
	</table>
	</form>
	<?php
}
elseif(isset($_GET["delete"]))
{
	?>
	<form method="post" action="?cp=news&func=feeds">
	<?php
	echo "Are you sure you wish to delete the ".$feed[$_GET["delete"]]["type"]." feed \"".$feed[$_GET["delete"]]["name"]."\"?  &nbsp;";
	?>This process is not easily reversable.<br>
	<input type="hidden" name="delete" value="<?php echo $_GET["delete"]; ?>">
	<input type="submit" value="Continue">
	</form>
	<?php
}
else
{
	if(isset($_POST["name"]))
	{
		$edit = isset($_POST["id"]) ? true : false;
		$id = 0;
		if(!$edit)
		{
			for($i = 0;$i < count($feed);$i++)
			{
				if($feed[$i]["id"] >= $id)
				{
					$id = $feed[$i]["id"] + 1;
				}
			}
		}
		else
		{
			$id = $_POST["id"];
		}
		$str = "\$feed[] = array(\"id\" => $id, \"type\" => \"RSS2\", \"name\" => \"".$_POST["name"]."\", \"description\" => \"".$_POST["description"]."\", \"url\" => \"".$_POST["url"]."\", \"query\" => \"".$_POST["query"]."\", \"file\" => \"".$_POST["file"]."\", \"categories\" => array(".implode(",", $_POST["category"])."));\n";
		$file = file("./feeds/feeds.php");
		if($edit)
		{
			$id++; //id is now the line number
			$file[$id] = $str;
		}
		else
		{
			$id = count($file) - 1; //again, line number
			$file[$id] = $str;
			$file[] = "?>";
		}
		$write = fopen("./feeds/feeds.php", "w");
		fwrite($write, implode("", $file));
		fclose($write);
		unset($feed);
		include "./feeds/feeds.php";
		if($edit)
		{
			echo "Feed edited successfully!";
		}
		else
		{
			echo "Feed added successfully!";
		}
		feeds_updateall(); //update the rss feeds upon edit/add
	}
	elseif(isset($_POST["delete"]))
	{
		$delete = $_POST["delete"];
		$file = file("./feeds/feeds.php");
		unset($file[$delete + 1]);
		$write = fopen("./feeds/feeds.php", "w");
		fwrite($write, implode($file));
		fclose($write);
		if((unlink($feed[$delete]["file"])) === false)
		{
			echo "Could not delete \"".$feed[$delete]["file"]."\", you must do so manualy.<br>";
		}
		unset($feed);
		include "./feeds/feeds.php";
	}
	elseif(isset($_GET["refresh"]))
	{
		if(rss2_update($_GET["refresh"]) === true)
		{
			echo "Feed updated!<br>";
		}
		else
		{
			echo "An error occurred while updating the feed.<br>";
		}
	}
	?>
	<table border="0" cellspacing="0" cellpadding="0" width="99%" align="center">
		<tr bgcolor="#7777FF">
			<th width="20%">Name</th>
			<th width="30%">Description</th>
			<th width="15%">File</th>
			<th width="15%">Categories</th>
			<th width="20%">Actions</th>
		</tr>
		<?php
		for($i = 0;$i < count($feed);$i++)
		{
			?>
			<tr>
				<td><?php echo stripslashes($feed[$i]["name"]); ?></td>
				<td><?php echo stripslashes($feed[$i]["description"]); ?></td>
				<td><?php echo $feed[$i]["file"]; ?></td>
				<td><?php
					unset($category);
					for($j = 0;$j < count($feed[$i]["categories"]);$j++)
					{
						for($k = 0;$k < count($categories);$k++)
						{
							if($categories[$k]["id"] == $feed[$i]["categories"][$j])
							{
								$category[] = $categories[$k]["name"];
							}
						}
					}
					echo implode(",", $category);
					?>
				</td>
				<td><a href="?cp=news&func=feeds&edit=<?php echo $i; ?>">Edit</a> <a href="?cp=news&func=feeds&delete=<?php echo $i; ?>">Delete</a>  <a href="?cp=news&func=feeds&refresh=<?php echo $i; ?>">Refresh</a></td>
			</tr>
			<?php
		}
		?>
	</table>
	<a href="?cp=news&func=feeds&newfeed=true">New Feed</a>
	<?php
}
include_body(3);
?>