<?php
// RSS 2.0 Feed
function RSS2_UpdateAll()
{
	global $feed;
	for($i = 0;$i < count($feed);$i++)
	{
		if($feed[$i]["type"] == "RSS2")
		{
			RSS2_Update($i);
		}
	}
}

function RSS2_Update($feedid)
{
	global $feed, $news;
	$rss = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>\n<rss version=\"2.0\">\n<channel>\n\t<title>".$feed[$feedid]["name"]."</title>\n\t<link>".$feed[$feedid]["url"]."</link>\n\t<description>".$feed[$feedid]["description"]."</description>\n";
	for($i = count($news) - 1;$i >= 0;$i--)
	{
		for($j = 0;$j < count($news[$i]["categories"]);$j++)
		{
			if(strpos(implode("|", $feed[$feedid]["categories"]), (string) $news[$i]["categories"][$j]) !== false)
			{
				$rss = $rss."\t<item>\n\t\t<title>".$news[$i]["title"]."</title>\n\t\t<link>".$feed[$feedid]["url"]."</link>\n\t\t<description>".stripslashes(preg_replace("/<(.*?)>/", "", $news[$i]["message"]))."</description>\n\t\t<guid>".htmlentities($feed[$feedid]["url"])."?".htmlentities($feed[$feedid]["query"])."newsid=".$news[$i]["id"]."</guid>\n\t</item>\n";
				break;
			}
		}
	}
	$rss = $rss."</channel>\n</rss>";
	if(!file_exists($feed[$feedid]["file"]))
	{
		if(($write = fopen($feed[$feedid]["file"], "w")) === false)
		{
			return false;
		}
		fclose($write);
		chmod($feed[$feedid]["file"], 0766);
	}
	if(($write = fopen($feed[$feedid]["file"], "w")) === false)
	{
		return false;
	}
	if(fwrite($write, $rss) === false)
	{
		return false;
	}
	fclose($write);
	return true;
}

function RSS2_Removecategory($catid)
{
	global $feed;
	$rss = array("<?php\n");
	$rss_file = file("feeds.php");
	for($i = 0;$i < count($feed);$i++)
	{
		if($feed[$i]["type"] == "RSS2")
		{
			if(strpos(implode("|", $feed[$i]["categories"]), (string) $catid) !== false)
			{
				for($j = 0;$j < count($feed[$i]["categories"]);$j++)
				{
					if($feed[$i]["categories"][$j] == $catid)
					{
						unset($feed[$i]["categories"][$j]);
					}
				}
			}
			$rss[] = "\$feed[] = array(\"id\" => ".$feed[$i]["id"].", \"type\" => \"RSS2\", \"name\" => \"".$feed[$i]["name"]."\", \"description\" => \"".$feed[$i]["description"]."\", \"url\" => \"".$feed[$i]["url"]."\", \"query\" => \"".$feed[$i]["query"]."\", \"file\" => \"".$feed[$i]["file"]."\", \"categories\" => array(".implode(",", $feed[$i]["categories"])."));\n";
		}
		else
		{
			$rss[] = $rss_file[$i + 1];
		}
	}
	$rss[] = "?>";
	$write = fopen("feeds.php", "w");
	fwrite($write, implode("", $rss));
	fclose($write);
}
?>