<?php
if(!defined("bitowl"))
{
	die();
}
include "./feeds/feedlib.php";
include_body(1);
include "menu.php";
include_body(2);
if(isset($_GET["edit"])) //News Editor
{
	?>
	<form method="post" action="?cp=news&func=mngnews">
	<input type="hidden" name="id" value="<?php echo $_GET["edit"]; ?>">
	<table border="0" cellspacing="0" cellpadding="0">
		<tr>
			<td>Title:</td>
			<td><input type="text" name="title" size="53" value="<?php echo stripslashes($news[$_GET["edit"]]["title"]); ?>"></td>
		</tr>
		<tr>
			<td valign="top">Message:</td>
			<td><textarea name="message" rows="8" cols="40"><?php echo stripslashes(str_replace("<br />", "\n", $news[$_GET["edit"]]["message"])); ?></textarea></td>
		</tr>
		<tr>
			<td valign="top">Category:</td>
			<td><select name="category[]" size="4" multiple="multiple">
				<?php
				if(count($categories) == 0)
				{
					die("FATAL ERROR: Could not find any categories.");
				}
				for($i = 0;$i < count($categories);$i++)
				{
					echo "<option value=\"".$categories[$i]["id"]."\"";
					if(strpos(implode("", $news[$_GET["edit"]]["categories"]), ''.$categories[$i]["id"]) !== false) //the ''. before the id makes this work
					{
						echo " selected=\"selected\"";
					}
					echo ">".$categories[$i]["name"]."</option>\n";
				}
				?>
				</select>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" value="Edit News"></td>
		</tr>
	</table>
	</form>
	<?php
}
elseif(isset($_GET["delete"])) //delete news
{
	?>
	<form method="post" action="?cp=news&func=mngnews">
	<input type="hidden" name="delete" value="<?php echo $_GET["delete"]; ?>">
	Are you sure you want to delete: <?php echo $news[$_GET["delete"]]["title"]; ?>?<br>
	<input type="submit" value="continue">
	</form>
	<?php
}
else
{
	if(isset($_POST["title"]))
	{
		$id = $_POST["id"];
		$_POST["message"] = str_replace(array("\n","&gt;","&lt;"), array("<br />",">","<"), $_POST["message"]);
		$str = "\$news[] = array(\"id\" => ".$news[$id]["id"].", \"title\" => \"".$_POST["title"]."\", \"message\" => \"".$_POST["message"]."\", \"author\" => \"".$news[$id]["author"]."\", \"date\" => ".$news[$id]["date"].", \"categories\" => array(".implode(",", $_POST["category"])."));\n";
		$file = file("db/news.php");
		$id += 2;
		$file[$id] = $str;
		$file = implode("", $file);
		$write = fopen("db/news.php", "w");
		fwrite($write, $file);
		fclose($write);
		unset($news, $categories);
		include "db/news.php";
		echo "News edited successfully!<br>";
	}
	elseif(isset($_POST["delete"]))
	{
		$file = file("db/comments.php");
		erase_file("db/comments.php");
		$write = fopen("db/comments.php", "a");
		for($i = 0;$i < count($file);$i++)
		{
			if($i != 0 || $i != count($file) - 1)
			{
				if($comment[$i - 1]["post"] != $_POST["delete"])
				{
					fwrite($write, $file[$i]);
				}
			}
			else
			{
				fwrite($write, $file[$i]);
			}
		}
		fclose($write);
		$line = $_POST["delete"] + 2;
		$file = file("db/news.php");
		erase_file("db/news.php");
		$write = fopen("db/news.php", "a");
		for($i = 0;$i < count($file);$i++)
		{
			if($i != $line)
			{
				fwrite($write, $file[$i]);
			}
		}
		fclose($write);
		unset($news, $categories);
		include "db/news.php";
		echo "News deleted successfully!<br>";
	}
	?>
	<table border="0" cellspacing="0" cellpadding="0" width="99%" align="center">
		<tr bgcolor="#7777FF">
			<th width="50%">Title</th>
			<th width="10%">Date</th>
			<th width="10%">Author</th>
			<th width="30%">Actions</th>
		</tr>
		<?php
		for($i = 0;$i < count($news);$i++)
		{
			if(isset($_GET["sort"]) && $_GET["sort"] == -1)
			{
				unset($_GET["sort"]);
			}
			if((isset($_GET["sort"]) && strpos(implode(",", $news[$i]["categories"]), $_GET["sort"]) !== false) || (!isset($_GET["sort"])))
			{
				?>
				<tr>
					<td><?php echo $news[$i]["title"]; ?></td>
					<td><?php echo date($_bitowl["news"]["date"], $news[$i]["date"]); ?></td>
					<td><?php echo $news[$i]["author"]; ?></td>
					<td><a href="?cp=news&func=mngnews&edit=<?php echo $i; ?>">Edit</a> <a href="?cp=news&func=mngnews&delete=<?php echo $i; ?>">Delete</a> <a href="?cp=news&func=comments&newsid=<?php echo $i; ?>">Comments</a></td>
				</tr>
				<?php
			}
		}
		?>
		<tr>
			<td colspan="3" valign="top"><a href="?cp=news&func=addnews">Add News</a></td>
			<td align="right">
				<form method="get" action="index.php">
				<input type="hidden" name="cp" value="news">
				<input type="hidden" name="func" value="mngnews">
				News Filter: <select name="sort">
				<option value="-1" selected="selected">No Filter</option>
				<?php
				for($i = 0;$i < count($categories);$i++)
				{
					echo "<option value=\"".$categories[$i]["id"]."\">".stripslashes($categories[$i]["name"])."</option>";
				}
				?>
				</select>
				<input type="submit" value="Filter">
				</form>
			</td>
		</tr>
	</table>
	<?php
}
include_body(3);
if(isset($feed) && (isset($_POST["title"]) || isset($_POST["delete"])))
{
	feeds_updateall();
}
?>